

// Called from PlayerConnect
PlayerConnect()
{
	Cleanup();

	// Start threads
	self thread StartPlayerThreads();
}

// Called from PlayerDisconnect
PlayerDisconnect()
{
	// Kill running threads
	self notify("cod2_killthreads");

	// Clear variables etc...
	CleanupKilled();
}

PlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime)
{
	// Block friendly melee in some cases (body search, etc...)
	if(level.cod2_teamplay && isPlayer(self) && isPlayer(eAttacker) && self.sessionteam == eAttacker.sessionteam && sMeansOfDeath == "MOD_MELEE")
	{
		if(isDefined(self.cod2_tripwiremessage) || isDefined(self.cod2_turretmessage))
			return -1;
	}

	// Damage modifiers
//	if(sMeansOfDeath != "MOD_MELEE" && isdefined(level.cod2_dmgmod[sWeapon]))
//		iDamage = int(iDamage * level.cod2_dmgmod[sWeapon]);

	// Stop damage from teamkiller
	if(level.cod2_teamplay && isPlayer(eAttacker) && (self != eAttacker) && (self.pers["team"] == eAttacker.pers["team"]))
	{
		if(eAttacker.pers["cod2_teamkiller"])
		{
			eAttacker.friendlydamage = true;
			iDamage = int(iDamage * .5);
			// Make sure at least one point of damage is done
			if(iDamage < 1)
				iDamage = 1;

			eAttacker finishPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime);
			eAttacker.friendlydamage = undefined;

			friendly = true;

			iDamage = -1;
		}
	}
	return iDamage;
}

PostPlayerDamage(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, psOffsetTime)
{
	// Splatter on attacker?
	//if(isPlayer(eAttacker) && (sMeansOfDeath == "MOD_MELEE" || distance(eAttacker.origin , self.origin ) < 40 ) )
		//eAttacker thread cod2\_bloodyscreen::Splatter_View();

	// Still alive?
	if(isalive(self))
	{	
		// Pains sound
		if(level.cod2_painsound)
			self painsound();

		// Do helmetpopping etc... ?
		switch(sHitLoc)
		{
			case "helmet":
			case "head":
				//self thread cod2\_bloodyscreen::Splatter_View();
				//if( randomInt(100) < level.cod2_pophelmet && !self.cod2_helmetpopped)
					//self cod2\_popping::popHelmet( vDir, iDamage );
				break;
		}
	
/*		// Do stuff
		switch(sHitLoc)
		{
			case "right_hand":
			case "left_hand":
			case "gun":
				if( !isdefined(level.cod2_merciless) && randomInt(100)<level.cod2_droponhandhit)        					self dropItem(self getcurrentweapon());
				break;
			
			case "right_arm_lower":
			case "left_arm_lower":
				if(!isdefined(level.cod2_merciless) && randomInt(100)<level.cod2_droponarmhit )
					self dropItem(self getcurrentweapon());
				break;
	
			case "right_foot":
			case "left_foot":
				if(randomInt(100)<level.cod2_triponfoothit)
					self thread spankme(1);
				break;

			case "right_leg_lower":
			case "left_leg_lower":
				if(randomInt(100)<level.cod2_triponleghit)
					self thread spankme(1);
				break;
		}*/
	}	
}

PlayerKilled(eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration)
{
	if(self.sessionteam == "spectator")
		return;

	if(isPlayer(attacker))
	{
		if(attacker == self) // killed himself
		{
		}
		else
		{
			if(level.cod2_teamplay && self.pers["team"] == attacker.pers["team"]) // killed by a friendly
			{
//				attacker cod2\_teamkilling::TeamKill();
			}
			else		// killed by an enemy
			{
			}
		}
	}
	else // If you weren't killed by a player, you were in the wrong place at the wrong time
	{
	}

	dopop = false;
	// Check for headpopping
	switch(sHitLoc)
	{
		case "head":
		case "helmet":
			//self thread cod2\_bloodyscreen::Splatter_View();
			//if( randomInt(100) < level.cod2_pophelmet && !self.cod2_helmetpopped)
				//self cod2\_popping::popHelmet( vDir, iDamage );
//			if( level.cod2_popheadbullet && sMeansOfDeath != "MOD_MELEE" && (cod2\_util::isWeaponType("rifle",sWeapon) //|| cod2\_util::isWeaponType("sniper",sWeapon) || cod2\_util::isWeaponType("turret",sWeapon)) )
//				dopop = true;
			break;
		default:
			break;
	}
//	iprintln("sMoD:"+sMeansOfDeath + " iDmg:" + iDamage + " sHL:" + sHitLoc);
//	switch(sMeansOfDeath)
	{
//		case "MOD_MELEE":
//			if(level.cod2_popheadmelee && iDamage>=100 )
//				dopop = true;
//			break;
//		case "MOD_PROJECTILE":
//		case "MOD_PROJECTILE_SPLASH":
//		case "MOD_GRENADE_SPLASH":
//		case "MOD_EXPLOSIVE":
//			if(level.cod2_popheadexplosion && iDamage>=100 )
//				dopop = true;
//			break;
//		default:
//			break;
	}
//
//	if(dopop)
	{
//		//if(randomInt(100) < level.cod2_pophead && !self.cod2_headpopped)
//			//self cod2\_popping::popHead( vDir, iDamage);
//		//else if(randomInt(100) < level.cod2_pophelmet && !self.cod2_helmetpopped)
//			//self cod2\_popping::popHelmet( vDir, iDamage);
	}
//
	// Drop health
//	cod2\_healthpacks::dropHealth();

	// Clear variables etc...
	CleanupKilled();
}

/////////////
// Threads //
/////////////

StartPlayerThreads()
{
	// End this thread on disconnect only
	self endon("disconnect");

	for(;;)
	{
		// Wait for player to spawn
		self waittill("spawned_player");
//		RunOnSpawn();
		wait .05;
	}
}

// Thread run on each player, every second
EverySecondThread()
{
	self endon("cod2_killthreads");

	sprinthudvisible = false;
	self.cod2_pace = 0;

	oldprimary = "sprint_mp";
	oldammo = 0;
	oldclip = 0;
	oldprimaryb = "sprint_mp";
	oldammob = 0;
	oldclipb = 0;

	ch_count=0;

	if(level.cod2_teamplay)
		myteam = self.sessionteam;
	else
		myteam = self.pers["team"];

	oldpos = self.origin;

	while( isPlayer(self) && isAlive(self) && self.sessionstate=="playing" )
	{
		delayed = 0;
//		cod2\_healthbar::UpdateHealthBar();

		// Get the current weapon
		cw = self getCurrentWeapon();

		// Get the stance every second
		self.cod2_stance = self cod2\_util::GetStance(false);

		// Show/Hide the sprint hint
//		if(level.cod2_sprint && level.cod2_sprinthudhint)
		{
//			if(!sprinthudvisible && self.cod2_sprinttime && !self.cod2_sprinting && self.cod2_pace && level.cod2_sprint>self.cod2_stance)
			{
				if(isdefined(self.cod2_sprinthud_hint))
				{
					self.cod2_sprinthud_hint fadeOverTime (1); 
					self.cod2_sprinthud_hint.alpha = 1;
					sprinthudvisible = true;
				}
			}
//			else if(sprinthudvisible && (self.cod2_sprinting || !self.cod2_pace || //level.cod2_sprint<=self.cod2_stance) )
			{
				{
					if(isdefined(self.cod2_sprinthud_hint))
					{
						self.cod2_sprinthud_hint fadeOverTime (1); 
						self.cod2_sprinthud_hint.alpha = 0;
						sprinthudvisible = false;
					}
				}
			}
		}

		// Save old weapon data
//		if(level.cod2_sprint)
		{
			// Save 1 second old data
			if(oldprimary != "sprint_mp")
			{
				self.cod2_oldprimary2 = oldprimary;
				self.cod2_oldammo2 = oldammo;
				self.cod2_oldclip2 = oldclip;
			}
			if(oldprimaryb != "sprint_mp")
			{
				self.cod2_oldprimaryb = oldprimaryb;
				self.cod2_oldammob = oldammob;
				self.cod2_oldclipb = oldclipb;
			}
			
			// Save new data
			oldprimary 	= self getWeaponSlotWeapon("primary");
			oldammo 	= self getWeaponSlotAmmo("primary");
			oldclip 	= self getWeaponSlotClipAmmo("primary");
			oldprimaryb = self getWeaponSlotWeapon("primaryb");
			oldammob 	= self getWeaponSlotAmmo("primaryb");
			oldclipb 	= self getWeaponSlotClipAmmo("primaryb");
		}

		// Be un-nice to Unknown Players?
		if(level.cod2_unknownmethod && self cod2\_util::isUnknown())
		{
			self iprintlnbold("^" + randomInt(8) + "Change your name!");
			switch(level.cod2_unknownmethod)
			{
				case 1:
					self dropItem(self getcurrentweapon());
					break;
				case 2:
					self shellshock("default", 1);;
					break;
				default:
					break;
			}
		}

		// Override client cvars
		if(ch_count>=15)
		{
			// Allow crosshairs?
			switch(level.cod2_allowcrosshair)
			{
				case 2:		// Force crosshair on
					self setClientCvar("cg_drawcrosshair", "1");
					wait 0.05;
					delayed += 0.05;
					break;

				case 1:		// Let player choose
					break;

				default:		// Force crosshair off
					self setClientCvar("cg_drawcrosshair", "0");
					wait 0.05;
					delayed += 0.05;
					break;
			}
			// Allow crosshairs names?
			switch(level.cod2_allowcrosshairnames)
			{
				case 2:		// Force crosshair names on
					self setClientCvar("cg_drawcrosshairnames", "1");
					wait 0.05;
					delayed += 0.05;
					break;

				case 1:		// Let player choose
					break;

				default:		// Force crosshair names off
					self setClientCvar("cg_drawcrosshairnames", "0");
					wait 0.05;
					delayed += 0.05;
					break;
			}
			// Allow crosshairs to switch color when aiming enemies?
			switch(level.cod2_allowcrosshaircolor)
			{
				case 2:		// Force crosshair color on
					self setClientCvar("cg_crosshairenemycolor", "1");
					wait 0.05;
					delayed += 0.05;
					break;

				case 1:		// Let player choose
					break;

				default:		// Force crosshair color off
					self setClientCvar("cg_crosshairenemycolor", "0");
					wait 0.05;
					delayed += 0.05;
					break;
			}
			if(level.cod2_stopclientexploits)
			{
				self setClientCvar("r_lighttweakambient","0");	// "glowing" models
				wait 0.05;
				delayed += 0.05;
				self setClientCvar("r_lodscale","1");		// See through bushes/trees
				wait 0.05;
				delayed += 0.05;
				self setClientCvar("mss_Q3fs","1");			// Ambient sounds
				wait 0.05;
				delayed += 0.05;
				self setClientCvar("r_polygonOffsetBias","-1");	// Not sure what this does
				wait 0.05;
				delayed += 0.05;
				self setClientCvar("r_polygonOffsetScale","-1");// Same here, not a clue...
			}
			if(level.cod2_quickfadecompassdots)
			{
				self setClientCvar("cg_hudCompassSoundPingFadeTime","0");
				wait 0.05;
				delayed += 0.05;
			}
			ch_count=randomInt(15); // Use a random interval between cvar forcing to create some chaos (1-15 seconds)
		}
		ch_count++;

		// Do some unlimted voodoo magic to the ammo counters
//		if(level.cod2_unlimitedammo)
//		{
//			self setWeaponSlotAmmo("primary", 999);
//			self setWeaponSlotAmmo("primaryb", 999);
//			if(level.cod2_unlimitedammo == 2)
//			{
//				self setWeaponSlotClipAmmo("primary", 999);
//				self setWeaponSlotClipAmmo("primaryb", 999);
//			}
//		}
//		if(level.cod2_unlimitedgrenades)
//		{
//			sWeapon = cod2\_util::GetGrenadeType(game[myteam]);
//			ammo = self getammocount(sWeapon);
//			if(!ammo)	self giveWeapon(sWeapon);
//			self setWeaponClipAmmo(sWeapon, 999);
//		}
//		if(level.cod2_unlimitedsmokegrenades)
//		{
//			sWeapon = cod2\_util::GetSmokeGrenadeType(game[myteam]);
//			ammo = self getammocount(sWeapon);
//			if(!ammo)	self giveWeapon(sWeapon);
//			self setWeaponClipAmmo(sWeapon, 999);
//		}

		// Calculate current speed
//		wait 1 - delayed;				// Wait 1 seconds minus whatever we were delayed while setting cvars
		newpos = self.origin;
		speed = distance(oldpos,newpos);
		oldpos = newpos;

		if (speed > 20)
			self.cod2_pace = 1;
		else
			self.cod2_pace = 0;
	}
}

// Thread run on each player, every frame
EveryFrameThread()
{
	if(level.cod2_teamplay)
		team = self.sessionteam;
	else
		team = self.pers["team"];

	if(team == "axis")
		otherteam = "allies";
	else
		otherteam = "axis";

	self endon("cod2_killthreads");

//	mindist = 9999;
//	maxdist = 0;
	count = 0;
//	for(;;)
	{
		count++;
		// Get the stance every half second
		if(count>10)
		{
			self.cod2_stance = self cod2\_util::GetStance(false);
			count = 0;
		}
		
		myammo	= self getammocount(cod2\_util::GetGrenadeType(game[team]));
		otherammo 	= self getammocount(cod2\_util::GetGrenadeType(game[otherteam]));
		ammo = myammo + otherammo;
		if( level.cod2_tripwire && ammo>1 && self.cod2_stance==2 && !isDefined(self.cod2_turretmessage) && !isDefined(self.cod2_tripwiremessage))
//			self thread cod2\_tripwire::checkTripwirePlacement(team, otherteam, myammo, otherammo);

/*		if(self meleeButtonPressed())
		{
			while(self meleeButtonPressed())
				wait .05;
			level thread cod2\_util::DropPiano(self);
		}*/
//		z = self.origin[2];
		wait .05;
/*		dist = self.cod2_spinemarker.origin[2] - z;
		if(dist<mindist) mindist = dist;
		if(dist>maxdist) maxdist = dist;
		if(self meleebuttonpressed())
		{
			self iprintlnbold("Min:" + mindist + " Max:" + maxdist);
			mindist = 9999;
			maxdist = 0;
		}*/
	}
}

///////////////
// Functions //
///////////////

Cleanup()
{
	CleanupKilled();
	CleanupSpawned();

//	cod2\_teamkilling::Cleanup();
//	cod2\_welcomemessages::Cleanup();
}

CleanupKilled()
{
	// Create/Reset variables
	if(!isdefined(self.pers["cod2_unknown_name"]))	self.pers["cod2_unknown_name"] = "Unknown Soldier";
	self.cod2_stance = 0;

	// Remove spine marker if present
	if(isdefined(self.cod2_spinemarker))
	{
		self.cod2_spinemarker unlink();
		self.cod2_spinemarker delete();
	}

//	cod2\_healthbar::CleanupKilled();
//	cod2\_laserdot::CleanupKilled();
	//cod2\_popping::CleanupKilled();
//	cod2\_sprinting::CleanupKilled();
//	cod2\_tripwire::CleanupKilled();
}

CleanupSpawned()
{
	//cod2\_bloodyscreen::CleanupSpawned();
}

RunOnSpawn()
{
	CleanupSpawned();

	// Kill any running threads
	self notify("cod2_killthreads");

	// Limit ammo
//	cod2\_weaponlimiting::ammoLimiting();

	// Wait for threads to die
//	wait .05;

	// Attach spinemarker, used by GetStance()
	self.cod2_spinemarker = spawn("script_origin",(0,0,0));
	self.cod2_spinemarker linkto (self, "J_Spine4",(0,0,0),(0,0,0));	
//	self.cod2_spinemarker linkto (self, "J_Neck",(0,0,0),(0,0,0));	

	// Handle the Unknown Soldiers
	if(self cod2\_util::isUnknown())
	{
		// Rename Unknown Soldiers
		// Get names
		names = [];
		count = 0;
		name = cod2\_util::cvardef("cod2_unknown_name" + count, "", "", "", "string");
		while(name != "")
		{
			names[names.size] = name;
			count++;
			name = cod2\_util::cvardef("cod2_unknown_name" + count, "", "", "", "string");
		}
		if(names.size)
		{
			self.pers["cod2_unknown_name"] = names[randomInt(names.size)] + " " + randomInt(1000);
			self setClientCvar("name", self.pers["cod2_unknown_name"]);
			if(level.cod2_unknownrenamemsg != "none")
				self iprintlnbold(level.cod2_unknownrenamemsg);
		}

		// Make sure an unknown player can't do much damage
		if(level.cod2_unknownreflect)
			self.pers["cod2_teamkiller"] = true;
	}

	// Start new threads
//	self thread EverySecondThread();
//	self thread EveryFrameThread();

//	self cod2\_coldbreath::RunOnSpawn();
//	self cod2\_healthbar::RunOnSpawn();
//	self cod2\_laserdot::RunOnSpawn();
//	self cod2\_servermessages::RunOnSpawn();
//	self cod2\_sprinting::RunOnSpawn();
//	self cod2\_welcomemessages::RunOnSpawn();
}

painsound()
{
	if(level.cod2_teamplay)
		team = self.sessionteam;
	else
		team = self.pers["team"];

	nationality = game[team];
	num =  randomInt(level.cod2_voices[nationality]) + 1;

	scream = "generic_pain_" + nationality + "_" + num; // i.e. "generic_pain_german_2"
	self playSound(scream);
}
